
// Section 2 Review, Question 2 Solution

// Write an administration system that uses the browser for moderators to kick, mute, or ban a player.  Moderators
// should not be able to kick themselves, and a link should not be made for moderators.  A muted or banned player
// should not have the mute or banned link beside a player's name.  Update the browser form when an action has
// been made on a player.  The browser should be closed with a link.  Do not worry about unmuting or unbanning players.

world/mob = /mob/choosing

var/list
	banned = list()
	muted = list()
	administrators = list("unknownperson","dantom")

mob/choosing/Login()
	if(src.ckey in administrators)
		src.client.mob = new /mob/player/admin
	else
		src.client.mob = new /mob/player
	del(src)

mob/player
	Login()
		..()
		src.name = src.key

	admin
		Topic(href, list/href_list)
			..()
			var/action = href_list["action"]
			var/mob/target = locate(href_list["value"])
			switch(action)
				if("close")
					// close admin tool window
					src << browse(null, "window=admintool")
				if("kick")
					if(target) src.kick(target) // only kick target if target still exists
					src.admin_tool() // refresh screen by calling verb again
				if("mute")
					if(target) src.mute(target)
					src.admin_tool()
				if("ban")
					if(target) src.ban(target)
					src.admin_tool()

		proc
			kick(mob/M)
				world << "[M.name] has been kicked by [src.name]"
				del(M)

			mute(mob/M)
				world << "[M.name] has been muted by [src.name]"
				muted += M.ckey

			ban(mob/M)
				world << "[M.name] has been banned by [src.name]"
				banned += M.ckey

		verb/admin_tool()
			var/playerlist
			var/html

			for(var/client/C)
				var/mob/M = C.mob
				var/tools

				if(src != M && !(M.ckey in administrators)) // only generate tools if the user specified is not themselves, or is an administrator
					// only generate tools that can be done (don't give the mute command to a muted person)
					tools += "<a href=byond://?src=\ref[src]&action=kick&value=\ref[M]>Kick</a>"
					if(!(C.ckey in muted))
						tools += " <a href=byond://?src=\ref[src]&action=mute&value=\ref[M]>Mute</a>"
					if(!(C.ckey in banned))
						tools += " <a href=byond://?src=\ref[src]&action=ban&value=\ref[M]>Ban</a>"

				// add table rows for each player, and a column for the tools
				playerlist += {"
					<tr>
					  <td> [M.name] ([C.key]) </td>
					  <td> [tools] </td>
					</tr>
				"}

			// generate the HTML page with the generated player list in the table
			html = {"
				<html>
				  <head> <title> Admin Tool </title> </head>
				  <body>
				    <b>Admin Tool</b> <br />
				    <table width="100%" border="1">
				      [playerlist]
				    </table>
				    <a href=byond://?src=\ref[src]&action=close>\[Close Window\]</a>
				  </body>
				</html>
			"}

			src << browse(html, "window=admintool;size=500x300")



