
// Section 2 - "Communication", Example 5
// The user is able to click the links of any player who is currently logged in the game,
// and see his or her statistics.

mob
  var
    health
    mana
    strength

  Login()
    ..()
    health = rand(50,100)
    mana = rand(50,100)
    strength = rand(10,20)

  Topic(href, list/href_list)
    ..()
    var/action = href_list["action"]
    var/value = href_list["value"]
    switch(action)
      if("look")
        // use locate() to get the reference of the text returned by \ref
        var/target = locate(value)
        // if it exists (player hasn't logged out after window refreshed), call the look_at() function
        if(target) src.look_at(target)
      if("close")
        // close the window when the player clicks the 'close' button
        src << browse(null, "window=playerlist")

  proc
    look_at(mob/M)
      src << "<b>[M]'s stats: </b>"
      src << "Health: [M.health]"
      src << "Mana: [M.mana]"
      src << "Strength: [M.strength]"

  verb
    list_players()
      var/page
      var/players

      for(var/client/C)
        var/mob/M = C.mob
        players += \
        {"
          <tr>
            <td width="40%"> [M.name] </td>
            <td width="60%">
              <a href="byond://?src=\ref[src]&action=look&value=\ref[M]">
                Click to view statistics
              </a>
            </td>
          </tr>
        "}

      page = \
      {"
        <html>
          <head> <title>Player List</title> </head>
        <body>
          <b>Players connected:</b>
          <table width="100%" border="1">
            [players]
          </table>
          <a href="byond://?src=\ref[src]&action=close">\[Close Window\]</a>
        </body>
        </html>
      "}

/*
      for(var/mob/M in world)
        players += \
        {"
          <tr>
            <td width="40%"> [M.name] </td>
            <td width="60%"> <button onclick="send('look', '\ref[M]');">Statistics</button> </td>
          </tr>
        "}

      page = \
      {"
        <html>
          <head>
            <title>Player List</title>
            <script language="javascript">
              function send(action, value) {
                window.location="byond://?src=\ref[src]&action="+action+"&value="+value;
              }
            </script>
          </head>
        <body>
          <b>Players connected:</b>
          <table width="100%" border="1">
            [players]
          </table>
          <button onclick="send('close');">Close Window</button>
        </body>
        </html>
      "}
*/
      src << browse(page, "window=playerlist&size=500x300")
